## PhoshWayland

PhoshWayland — A wayland registry listener

## Functions

PhoshWayland * | phosh_wayland_get_default ()
GHashTable * | phosh_wayland_get_wl_outputs ()
gboolean | phosh_wayland_has_wl_output ()
struct org_kde_kwin_idle * | phosh_wayland_get_org_kde_kwin_idle ()
struct phosh_private * | phosh_wayland_get_phosh_private ()
uint32_t | phosh_wayland_get_phosh_private_version ()
struct wl_seat * | phosh_wayland_get_wl_seat ()
struct wl_shm * | phosh_wayland_get_wl_shm ()
struct xdg_wm_base * | phosh_wayland_get_xdg_wm_base ()
struct zwlr_foreign_toplevel_manager_v1 * | phosh_wayland_get_zwlr_foreign_toplevel_manager_v1 ()
struct zwlr_input_inhibit_manager_v1 * | phosh_wayland_get_zwlr_input_inhibit_manager_v1 ()
struct zwlr_layer_shell_v1 * | phosh_wayland_get_zwlr_layer_shell_v1 ()
struct zwlr_gamma_control_manager_v1 * | phosh_wayland_get_zwlr_gamma_control_manager_v1 ()
struct zwlr_output_manager_v1 * | phosh_wayland_get_zwlr_output_manager_v1 ()
struct zwlr_output_power_manager_v1 * | phosh_wayland_get_zwlr_output_power_manager_v1 ()
struct zxdg_output_manager_v1 * | phosh_wayland_get_zxdg_output_manager_v1 ()
struct zwlr_screencopy_manager_v1 * | phosh_wayland_get_zwlr_screencopy_manager_v1 ()
struct zwp_virtual_keyboard_manager_v1 * | phosh_wayland_get_zwp_virtual_keyboard_manager_v1 ()
void | phosh_wayland_roundtrip ()
PhoshWaylandSeatCapabilities | phosh_wayland_get_seat_capabilities ()

## Properties

PhoshWaylandSeatCapabilities | seat-capabilities | Read
GHashTable * | wl-outputs | Read

## Types and Values

enum | PhoshWaylandSeatCapabilities
#define | PHOSH_PRIVATE_GET_THUMBNAIL_SINCE
#define | PHOSH_PRIVATE_KBD_EVENTS_SINCE
#define | PHOSH_PRIVATE_STARTUP_NOTIFY_SINCE
#define | PHOSH_PRIVATE_SHELL_READY_SINCE
#define | PHOSH_TYPE_WAYLAND
| PhoshWayland

## Object Hierarchy

        GFlags
        ╰── PhoshWaylandSeatCapabilities
        GObject
        ╰── PhoshWayland

## Description

The PhoshWayland singleton is responsible for listening to wayland registry events registering the objects that show up there to make them available to Phosh's other classes.

## Functions

### phosh_wayland_get_default ()

    PhoshWayland *
    phosh_wayland_get_default (void);

### phosh_wayland_get_wl_outputs ()

    GHashTable *
    phosh_wayland_get_wl_outputs (PhoshWayland *self);

#### Parameters

self | The PhoshWayland singleton |

#### Returns

A list of outputs as a GHashTable keyed by the output's name with wl_output's as values.

[transfer none]

### phosh_wayland_has_wl_output ()

    gboolean
    phosh_wayland_has_wl_output (PhoshWayland *self,
                                 struct wl_output *wl_output);

### phosh_wayland_get_org_kde_kwin_idle ()

    struct org_kde_kwin_idle *
    phosh_wayland_get_org_kde_kwin_idle (PhoshWayland *self);

### phosh_wayland_get_phosh_private ()

    struct phosh_private *
    phosh_wayland_get_phosh_private (PhoshWayland *self);

### phosh_wayland_get_phosh_private_version ()

    uint32_t
    phosh_wayland_get_phosh_private_version
                                   (PhoshWayland *self);

### phosh_wayland_get_wl_seat ()

    struct wl_seat *
    phosh_wayland_get_wl_seat (PhoshWayland *self);

### phosh_wayland_get_wl_shm ()

    struct wl_shm *
    phosh_wayland_get_wl_shm (PhoshWayland *self);

### phosh_wayland_get_xdg_wm_base ()

    struct xdg_wm_base *
    phosh_wayland_get_xdg_wm_base (PhoshWayland *self);

### phosh_wayland_get_zwlr_foreign_toplevel_manager_v1 ()

    struct zwlr_foreign_toplevel_manager_v1 *
    phosh_wayland_get_zwlr_foreign_toplevel_manager_v1
                                   (PhoshWayland *self);

### phosh_wayland_get_zwlr_input_inhibit_manager_v1 ()

    struct zwlr_input_inhibit_manager_v1 *
    phosh_wayland_get_zwlr_input_inhibit_manager_v1
                                   (PhoshWayland *self);

### phosh_wayland_get_zwlr_layer_shell_v1 ()

    struct zwlr_layer_shell_v1 *
    phosh_wayland_get_zwlr_layer_shell_v1 (PhoshWayland *self);

### phosh_wayland_get_zwlr_gamma_control_manager_v1 ()

    struct zwlr_gamma_control_manager_v1 *
    phosh_wayland_get_zwlr_gamma_control_manager_v1
                                   (PhoshWayland *self);

### phosh_wayland_get_zwlr_output_manager_v1 ()

    struct zwlr_output_manager_v1 *
    phosh_wayland_get_zwlr_output_manager_v1
                                   (PhoshWayland *self);

### phosh_wayland_get_zwlr_output_power_manager_v1 ()

    struct zwlr_output_power_manager_v1 *
    phosh_wayland_get_zwlr_output_power_manager_v1
                                   (PhoshWayland *self);

### phosh_wayland_get_zxdg_output_manager_v1 ()

    struct zxdg_output_manager_v1 *
    phosh_wayland_get_zxdg_output_manager_v1
                                   (PhoshWayland *self);

### phosh_wayland_get_zwlr_screencopy_manager_v1 ()

    struct zwlr_screencopy_manager_v1 *
    phosh_wayland_get_zwlr_screencopy_manager_v1
                                   (PhoshWayland *self);

### phosh_wayland_get_zwp_virtual_keyboard_manager_v1 ()

    struct zwp_virtual_keyboard_manager_v1 *
    phosh_wayland_get_zwp_virtual_keyboard_manager_v1
                                   (PhoshWayland *self);

### phosh_wayland_roundtrip ()

    void
    phosh_wayland_roundtrip (PhoshWayland *self);

### phosh_wayland_get_seat_capabilities ()

    PhoshWaylandSeatCapabilities
    phosh_wayland_get_seat_capabilities (PhoshWayland *self);

## Types and Values

### enum PhoshWaylandSeatCapabilities

These match wl_seat_capabilities

#### Members

PHOSH_WAYLAND_SEAT_CAPABILITY_NONE | no device detected |
PHOSH_WAYLAND_SEAT_CAPABILITY_POINTER | the seat has pointer devices |
PHOSH_WAYLAND_SEAT_CAPABILITY_KEYBOARD | the seat has one or more keyboards |
PHOSH_WAYLAND_SEAT_CAPABILITY_TOUCH | the seat has touch devices |

### PHOSH_PRIVATE_GET_THUMBNAIL_SINCE

    #define PHOSH_PRIVATE_GET_THUMBNAIL_SINCE  4

### PHOSH_PRIVATE_KBD_EVENTS_SINCE

    #define PHOSH_PRIVATE_KBD_EVENTS_SINCE     5

### PHOSH_PRIVATE_STARTUP_NOTIFY_SINCE

    #define PHOSH_PRIVATE_STARTUP_NOTIFY_SINCE 6

### PHOSH_PRIVATE_SHELL_READY_SINCE

    #define PHOSH_PRIVATE_SHELL_READY_SINCE    6

### PHOSH_TYPE_WAYLAND

    #define PHOSH_TYPE_WAYLAND phosh_wayland_get_type()

### PhoshWayland

    typedef struct _PhoshWayland PhoshWayland;

## Property Details

### The `“seat-capabilities”` property

      “seat-capabilities”        PhoshWaylandSeatCapabilities

The current seat capabilities.

Owner: PhoshWayland

Flags: Read

### The `“wl-outputs”` property

      “wl-outputs”               GHashTable *

The currently known wayland outputs.

Owner: PhoshWayland

Flags: Read